VERSION 5.00
Begin VB.Form frmAddIn 
   Appearance      =   0  'Flat
   AutoRedraw      =   -1  'True
   BackColor       =   &H00000000&
   Caption         =   "Document Map"
   ClientHeight    =   6270
   ClientLeft      =   2130
   ClientTop       =   1890
   ClientWidth     =   3975
   FillStyle       =   0  'Solid
   Icon            =   "frmAddIn.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   418
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   265
   StartUpPosition =   2  'CenterScreen
   Tag             =   "0"
   Begin VB.Timer TimForceRefresh 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   2670
      Top             =   510
   End
   Begin VB.Timer TimUpdate 
      Interval        =   1500
      Left            =   2670
      Top             =   60
   End
   Begin VB.PictureBox PicGraph 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BeginProperty Font 
         Name            =   "Segoe Condensed"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00808080&
      Height          =   6210
      Left            =   0
      ScaleHeight     =   412
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   166
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   15
      Width           =   2520
   End
   Begin VB.Menu mnuMain 
      Caption         =   "mnuMain"
      Visible         =   0   'False
      Begin VB.Menu mnuMark 
         Caption         =   "Mark #1"
         Index           =   1
      End
      Begin VB.Menu mnuMark 
         Caption         =   "Mark #2"
         Index           =   2
      End
      Begin VB.Menu mnuMark 
         Caption         =   "Mark #3"
         Index           =   3
      End
      Begin VB.Menu mnuMark 
         Caption         =   "Insert line -------"
         Index           =   4
      End
      Begin VB.Menu mnuSep 
         Caption         =   "-"
      End
      Begin VB.Menu MnuOnTop 
         Caption         =   "OnTop"
      End
   End
End
Attribute VB_Name = "frmAddIn"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'===========================================================================================
'Document Map v1.1 - 26/07/19                           By Pedro Aguirrezabal (Shagratt@ARG)
'===========================================================================================
'It display a color coded representation of the current code window.
'It shows what part of the code you're seeing in the editor.
'Left mouse click allow you to jump to any part of the code instantly
'Right mouse button brings a menu with:
'   -Add colored marks (that are part of the code so they are saved)
'   -Always on top or not
'Its flicker free
'It has checks to not redraw when there is no code/views changes (its fast and not cpu intensive)
'Default Colors:
'   -Grey: Normal code
'   -Light Grey: Begin of sub/function
'   -Green: Comments
'
'Cause I dont know how to access the Flags/Breakpoints I added a few special delimiters
'that draw visual clues on the Document Map. (Must be the first chars in the line, except TODO)
'
'   '*-  = Full purple line
'   '*1  = Red mark on the right
'   '*2  = Yellow mark on the right
'   '*3  = Cyan mark on the right
'   'TODO: = Shorter purple mark on the right
'
'
' IMPORTANT: While debuggin AddIns from the IDE I lost functionality of the right mouse (Definition,Last position,etc.) so before
' compiling do a backup of your registry key HKCU\Software\Microsoft\Visual Basic\6.0\UI
' If this happens to you deleting that key and reopening vb6 restore the lost functionality
'
'
'Changelog
'=========
'v1.2 - 27/07/19
'   +Full analisis for marks (before was skipping lines if code was too big)
'   +Double click colpase the window and put it on top (double click top line of title
'    and windows will extend it again)
'
'v1.1 - 26/07/19
'   +Change focus back to project so mousewheel works after clicking document map
'   +Moving while keeping the mouse pressed allow smooth scrolling through the document map
'   +Right mouse menu give option to set / remove marks
'   +Codeview are now centered on the click
'   +While mouse button held it show the name of Sub / Fuction in that part of code
'   +Support for CodeSmart bookmarks
'
'v1.0 - 24/07/19
'   +Basic version as proof of concept (it just 'works') and is my first AddIn. There is a lot
'    of room for improvement.





'for OnTop
Private Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type
Private Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hDC As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Private Const DT_WORDBREAK = &H10

'instance of the VB Environment
Public VBInstance As VBIDE.VBE
Public Connect As Connect
'Colors
Dim cColorText&, cColorComment&, cColorSubs
Dim cColorMark1&, cColorMark2&, cColorMark3&, cColorMark4FullRow&
Dim cColorMarkTodo&

Dim GraphStep!, GraphMult!, gDrawWidth& 'For detecting line on click and graphic drawing scale
Dim Totlines&, CurrentTop&, ModuleName$ 'Total number of lines of code to detect unneeded redraws
Dim bMouseHeldDown As Boolean

Dim ClickY! 'mouse Y clicked
Private OldFormHeight&, bIgnoreSizeChange As Boolean 'To collapse on top title doubleclick




'=============================
' LOAD (Entry point in form)
'=============================
Private Sub Form_Load()
On Error GoTo Err:
    
    PicGraph.Left = 400
    PicGraph.Visible = False


    cColorText = RGB(100, 100, 100) ' grey
    cColorComment = RGB(0, 78, 0)    ' Green
    cColorSubs = RGB(160, 160, 170) ' lighter grey
    
    cColorMark1& = RGB(200, 0, 0)  ' Red
    cColorMark2& = RGB(200, 200, 0) 'Yellow
    cColorMark3& = RGB(0, 200, 200)  'Cyan
    cColorMarkTodo& = RGB(255, 0, 200) 'Purple
    cColorMark4FullRow& = RGB(200, 100, 200)

    MnuOnTop_Click
    DrawLines
    
    'Hook
    Call WheelHook(Me.hWnd)

    Exit Sub
Err:
    TimUpdate.Enabled = False
    MsgBox "Document Map Error loading:" & Err.Description
End Sub


Private Sub Form_Unload(Cancel As Integer)
    'Release Hook
    Call WheelUnHook(Me.hWnd)
End Sub

'================================
'Show menu on right click
'================================
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If (Button = 2) Then
        ClickY = Y
        CheckForMarks
        PopupMenu mnuMain
    ElseIf (Button = 1) Then
        PicGraphScroll Y
    End If
End Sub

'================================
'Continuous scrolling
'================================
Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If (Button = 1) Then
        bMouseHeldDown = True
        ClickY = Y
        PicGraphScroll Y
        DoEvents
    End If
End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    bMouseHeldDown = False
End Sub

Public Sub MouseWheel(ByVal MouseKeys As Long, ByVal Rotation As Long, ByVal Xpos As Long, ByVal Ypos As Long)
    PassFocusToIde
    DrawLines
    TimForceRefresh.Enabled = True
End Sub

Public Sub PassFocusToIde()
    If Not (VBInstance.ActiveCodePane.Window Is Nothing) Then
        On Error Resume Next
        VBInstance.ActiveCodePane.Window.SetFocus
    End If
End Sub

'========================
'Form Resize
'========================
Private Sub Form_Resize()
On Error Resume Next
    'Min Size
    If (Me.Width <> 2645) Then Me.Width = 2645
    If Not (bIgnoreSizeChange) Then
        If (Me.Height < 6465) Then Me.Height = 6465
    Else
        bIgnoreSizeChange = False
    End If
    'PicGraph vertical scaling
    PicGraph.Height = Me.Height / Screen.TwipsPerPixelY
    
    'Force redraw after a interval to not keep updating constantly
    TimForceRefresh.Enabled = True
End Sub

'=====================================
'Colapse/form on double click
'=====================================
'Note: Expanding is done by windows itself when double clicking the top line of the title
Private Sub Form_DblClick()
    bIgnoreSizeChange = True
    If (Me.Height = 0) Then
        Me.Height = Screen.Height
        Me.Top = 0
    Else
        Me.Top = 0
        Me.Height = 0
    End If
End Sub

'=======================================
'Click in PopUp menu to add/remove marks
'=======================================
Private Sub mnuMark_Click(Index As Integer)
Dim Line&
Dim VBCP As VBIDE.CodePane
Dim VBCM As VBIDE.CodeModule

    Set VBCP = VBInstance.ActiveCodePane
    If (VBCP Is Nothing) Then Exit Sub
    Set VBCM = VBCP.CodeModule
    If (VBCM Is Nothing) Then Exit Sub
    
    Line& = CalcPicGraphToCodeLine(ClickY, VBCP, VBCM, False)
    
    'Sanity check
    If (Line& < 1) Then Exit Sub
    
    'Add the mark
    If (mnuMark(Index).Checked) Then
        Call RemoveMark(Index, Line&)
    Else
    
        Select Case Index
        Case 1
            VBCM.InsertLines Line&, "'*1"
        Case 2
            VBCM.InsertLines Line&, "'*2"
        Case 3
            VBCM.InsertLines Line&, "'*3"
        Case 4
            VBCM.InsertLines Line&, "'*-"
        End Select
    End If
    
'*-
    'Force refresh
    Totlines = -1
    DrawLines
    
End Sub

'=====================================
'Remove the selected mark
'=====================================
Private Sub RemoveMark(Index As Integer, Line&)
On Error GoTo Err:
Dim StartLine&, EndLine&, Range&, i&, LookFor$
Dim VBCP As VBIDE.CodePane
Dim VBCM As VBIDE.CodeModule

    Set VBCP = VBInstance.ActiveCodePane
    If (VBCP Is Nothing) Then Exit Sub
    Set VBCM = VBCP.CodeModule
    If (VBCM Is Nothing) Then Exit Sub
    
    'Calculate the lines arround the mouse
    Range& = VBCM.CodePane.CountOfVisibleLines / 2
    StartLine& = Line& - Range&
    'Sanity check
    If (StartLine& < 1) Then StartLine& = 1
    EndLine& = Line& + Range&
    If (EndLine& > Totlines) Then EndLine& = Totlines
    
    Select Case (Index)
    Case 1
        LookFor$ = "'*1"
    Case 2
        LookFor$ = "'*2"
    Case 3
        LookFor$ = "'*3"
    Case 4
        LookFor$ = "'*-"
    End Select
    
    'Search for the line cause the .Lines method its bugged and return more lines than it should
    For i = StartLine& To EndLine&
        If (VBCM.Find(LookFor$, i, 1, i, 5)) Then
            VBCM.DeleteLines i, 1
        End If
    Next i
Err:
End Sub

'===================================================
'Check if there is any mark arround the clicked area
'===================================================
Private Sub CheckForMarks()
Dim StartLine&, EndLine&, Range&, St&, En&, Col&
Dim VBCP As VBIDE.CodePane
Dim VBCM As VBIDE.CodeModule

    Set VBCP = VBInstance.ActiveCodePane
    If (VBCP Is Nothing) Then Exit Sub
    Set VBCM = VBCP.CodeModule
    If (VBCM Is Nothing) Then Exit Sub
    
    'Calculate the lines arround the mouse
    Range& = VBCM.CodePane.CountOfVisibleLines
    
    StartLine& = CalcPicGraphToCodeLine(ClickY, VBCP, VBCM, True)
    'Sanity check
    If (StartLine& < 1) Then StartLine& = 1
    EndLine& = StartLine& + Range&
    If (EndLine& > Totlines) Then EndLine& = Totlines
    
    
    'DEBUG CODE - Draw Range
'    Me.Caption = "Y: " & ClickY & ",StartLine: " & StartLine & ", EndLine: " & EndLine&
'    Totlines& = -1
'    DrawLines
'    Dim STY&, ENY&
'    STY = CalcCodeLineToPicGraph(StartLine&, VBCP, VBCM)
'    ENY& = CalcCodeLineToPicGraph(EndLine&, VBCP, VBCM)
'    Me.Line (0, ClickY)-(PicGraph.Width, ClickY), RGB(0, 255, 0)
'    Me.Line (0, STY)-(PicGraph.Width, STY), RGB(255, 15, 0)
'    Me.Line (0, ENY&)-(PicGraph.Width, ENY&), RGB(0, 255, 255)
    '
    
    'Disable all checks
    mnuMark(1).Checked = False
    mnuMark(2).Checked = False
    mnuMark(3).Checked = False
    mnuMark(4).Checked = False
    
    'Toggle mnu checks if marks are found
    St& = StartLine&: En& = EndLine& 'Find may change start/end so I pass a copy in other vars
    'Check if it analized all the block (so we dont stop on the first discarded one)
    Do
        If (VBCM.Find("'*1", St&, Col&, En&, 5)) Then
            'Aditional check: The marks should be in the beggining of line
            If (Col& = 1) Then
                mnuMark(1).Checked = True
                Exit Do
            End If
        End If
        St& = En& + 1: En& = EndLine&
    Loop While (St& <= EndLine&)
    
    'Find may change start/end so I pass a copy in other vars
    St& = StartLine&: En& = EndLine&: Col& = 0
    'Check if it analized all the block (so we dont stop on the first discarded one)
    Do
        If (VBCM.Find("'*2", St&, Col&, En&, 5)) Then
            'Aditional check: The marks should be in the beggining of line
            If (Col& = 1) Then
                mnuMark(2).Checked = True
                Exit Do
            End If
        End If
        St& = En& + 1: En& = EndLine&
    Loop While (St& <= EndLine&)

    St& = StartLine&: En& = EndLine&: Col& = 0
    'Check if it analized all the block (so we dont stop on the first discarded one)
    Do
        If (VBCM.Find("'*3", St&, Col&, En&, 5)) Then
            'Aditional check: The marks should be in the beggining of line
            If (Col& = 1) Then
                mnuMark(3).Checked = True
                Exit Do
            End If
        End If
        St& = En& + 1: En& = EndLine&
    Loop While (St& <= EndLine&)
    
    St& = StartLine&: En& = EndLine&: Col& = 0
    'Check if it analized all the block (so we dont stop on the first discarded one)
    Do
        If (VBCM.Find("'*-", St&, Col&, En&, 5)) Then
            'Aditional check: The marks should be in the beggining of line
            If (Col& = 1) Then
                mnuMark(4).Checked = True
                Exit Do
            End If
        End If
        St& = En& + 1: En& = EndLine&
    Loop While (St& <= EndLine&)
    
    
End Sub



'*-


'======================================
'Timer to force refresh when resizing
'======================================
Private Sub TimForceRefresh_Timer()
    bIgnoreSizeChange = False
    TimForceRefresh.Enabled = False
    'Force refresh
    Totlines = -1
    DrawLines
End Sub



'===================================
'Redraws after x interval if needed
'===================================
Private Sub TimUpdate_Timer()
    DrawLines
End Sub

'====================================
'Create a Graph of the code lines
'====================================
Private Sub DrawLines()
On Error GoTo Err:
Dim VBCP As VBIDE.CodePane
Dim VBCM As VBIDE.CodeModule
Dim LongestTextLine&, color&
Dim GposY& 'Vertical position when drawing on the Graph
Dim i&, j!
Dim Line$(), LineLen&()
    
    Set VBCP = VBInstance.ActiveCodePane
    If (VBCP Is Nothing) Then Exit Sub
    Set VBCM = VBCP.CodeModule
    If (VBCM Is Nothing) Then Exit Sub
    
    'Check for changes
    If (VBCM.CountOfLines = Totlines&) And (CurrentTop& = VBCP.TopLine) Then
        'Not much need for a full update, we wait for more changes
        Exit Sub
    End If
    'Update the number of lines/position
    Totlines& = VBCM.CountOfLines
    CurrentTop& = VBCP.TopLine
    
    'Clear
    PicGraph.Cls
    
    'If code is empty then clear and exit
    If (Totlines <= 0) Then
        Exit Sub
    End If
    
    'Get all the lines
    Line$ = Split(VBCM.Lines(1, Totlines&), vbCrLf)
    ReDim LineLen&(UBound(Line$))

    'Calculate all the lines
    For i = 0 To UBound(Line$)
          LineLen&(i) = Len(Line$(i))
          'Keep the longest one (not used right now)
          If (LineLen&(i) > LongestTextLine) Then LongestTextLine = LineLen&(i)
    Next i
    
    'If there is more lines of code than pixels in the picGraph calculate the step of drawing
    If (Totlines& > PicGraph.Height) Then
        'Draw skipping lines (< 1 scale)
        GraphStep = GraphStep = (Totlines& - VBCP.CountOfVisibleLines) / (PicGraph.Height - VBCP.CountOfVisibleLines)
        GraphMult! = 1
        gDrawWidth& = 1
    Else
        'Check if we can draw double line (too few lines of codes and window too big)
        'Dont do triple lines cause document map has no use on smaller code.
        If (PicGraph.Height / Totlines& > 2) Then
            'Draw all the lines in 2:1 scale
            GraphMult! = 0.5
            gDrawWidth& = 2
            GraphStep = 1
        Else
            'Draw all the lines in 1:1 scale
            GraphMult! = 1
            GraphStep! = 1
            gDrawWidth& = 1
        End If
    End If
    
    
    Dim LineStart&, LineEnd&, Special&
    Dim ForceSkip As Boolean 'To not draw over the full line
    
'    'Draw fully skipping lines (faster)
'    PicGraph.DrawMode = 13 'DrawModeConstants.vbCopyPen
'    PicGraph.DrawWidth = gDrawWidth&
'    For j = 0 To UBound(Line$) - 1 Step GraphStep
'        i = CLng(j)
'        'Select color for line
'        color& = SelectColor(Line$(i), 0, LineLen&(i), LineStart&, LineEnd&, Special&)
'        'Check for special
'        '#1 Line in the end Sub (draw both the end sub with a color and another background line)
'        If (Special = 1) Then
'            'Draw full line in dark grey
'            PicGraph.Line (0, GposY&)-(PicGraph.Width, GposY&), 1973790 ' 2631720 'RGB(40, 40, 40)
'        End Sub
'
'        'Draw the line
'        PicGraph.Line (LineStart&, GposY&)-(LineEnd&, GposY&), color&
'        GposY& = GposY& + gDrawWidth&
'    Next j
    
    'Begin the drawing procesing skiped lines for marks (slower)
    PicGraph.DrawMode = 13 'DrawModeConstants.vbCopyPen
    PicGraph.DrawWidth = gDrawWidth&
    For i = 0 To UBound(Line$) - 1 'Step GraphStep
        'Select color for line
        color& = SelectColor(Line$(i), 0, LineLen&(i), LineStart&, LineEnd&, Special&)
        'Special cases
        '#1 Line in the end Sub
        If (Special = 1) Then
            'Draw full line in dark grey...
            PicGraph.Line (0, GposY&)-(PicGraph.Width, GposY&), 1973790 ' 2631720 'RGB(40, 40, 40)
        ElseIf (Special = 2) Then
            PicGraph.Line (LineStart&, GposY&)-(LineEnd&, GposY&), color&
        ElseIf (Special = 3) Then
            PicGraph.Line (LineStart&, GposY&)-(LineEnd&, GposY&), color&
            'and Signal to not draw anything else (we want the line to not overlap)
            ForceSkip = True
        End If

        'Skipping enabled check if we need to draw this line
        If (i = CLng(j)) Then
            'Check if the line was reserved for a special mark so we dont draw over it
            If Not (ForceSkip) Then
                'Draw this line
                PicGraph.Line (LineStart&, GposY&)-(LineEnd&, GposY&), color&
            Else
                'Remove the flag for the next pixel line
                ForceSkip = False
            End If
            'Move down the Y axis for next drawing and next stepping
            GposY& = GposY& + gDrawWidth&
            j = j + GraphStep
        End If

    Next i
    
    
    'Draw active portrait
    PicGraph.DrawMode = 12 'DrawModeConstants.vbMergePenNot
    'PicGraph.DrawWidth = 1
    Dim VisLineTop&, VisLineBot&
    VisLineTop& = (VBCP.TopLine / GraphStep!)
    VisLineBot& = (VisLineTop& + (VBCP.CountOfVisibleLines / GraphStep!)) * gDrawWidth&
    VisLineTop& = VisLineTop& * gDrawWidth&
    PicGraph.Line (0, VisLineTop&)-(PicGraph.Width, VisLineBot&), RGB(255, 192, 128), BF
    
    If Not (bMouseHeldDown) Then
        'Draw the buffer on the form avoiding flickering
        Me.PaintPicture PicGraph.Image, 0, 0
         
        'In case we have another tooltip system. The current one dont need to do anything to clear
        'SetTooltip ""
    Else
        'Do nothing. The painting is done when looking for a
        'Sub / function name
    End If
Err:
End Sub

'==========================================
'Return the color to draw that line of text
'And in some cases change the lineLenght
'==========================================
'Special:
'#1 End sub (draw full line)
'#2 Not skipeable drawing
Private Function SelectColor(s$, St&, En&, ByRef LineStart&, ByRef LineEnd&, ByRef Special&) As Long
    LineStart& = St&
    LineEnd& = En&
    Special = 0
    If (s = "") Then
        SelectColor = cColorText
    ElseIf (Left$(Trim(s$), 3) = "'*-") Then
        SelectColor = cColorMark4FullRow& 'Full Line
        LineEnd& = PicGraph.Width
        Special = 3
    ElseIf (Left$(Trim(s$), 3) = "'*1") Then
        SelectColor = cColorMark1&
        LineStart& = PicGraph.Width - (PicGraph.Width / 5)
        LineEnd& = PicGraph.Width
        Special = 2
    ElseIf (Left$(Trim(s$), 3) = "'*2") Then
        SelectColor = cColorMark2&
        LineStart& = PicGraph.Width - (PicGraph.Width / 5)
        LineEnd& = PicGraph.Width
        Special = 2
    ElseIf (Left$(Trim(s$), 3) = "'*3") Then
        SelectColor = cColorMark3&
        LineStart& = PicGraph.Width - (PicGraph.Width / 5)
        LineEnd& = PicGraph.Width
        Special = 2
    ElseIf (InStr(1, s, "'TODO:", 1) > 0) Then
        SelectColor = cColorMarkTodo& ' Brigther Green
        LineStart& = PicGraph.Width - (PicGraph.Width / 8)
        LineEnd& = PicGraph.Width
        Special = 2
    ElseIf (Left$(Trim(s$), 6) = "'CSBmk") Then
        SelectColor = RGB(80, 90, 160) ' Lila (?)
        LineStart& = PicGraph.Width - (PicGraph.Width / 8)
        LineEnd& = PicGraph.Width
        Special = 2
    ElseIf (Left$(Trim(s$), 1) = "'") Then
        SelectColor = cColorComment
    ElseIf (InStr(1, s, "private function", 1) > 0) Then
        SelectColor = cColorSubs
    ElseIf (InStr(1, s, "public function", 1) > 0) Then
        SelectColor = cColorSubs
    ElseIf (InStr(1, s, "private sub", 1) > 0) Then
        SelectColor = cColorSubs
    ElseIf (InStr(1, s, "public sub", 1) > 0) Then
        SelectColor = cColorSubs
    ElseIf (InStr(1, s, "End sub", 1) > 0) Then
        SelectColor = cColorSubs
        Special = 1
    Else
        SelectColor = cColorText
    End If
End Function



'================================
'Scroll editor to thumbnail point
'================================
Private Sub PicGraphScroll(Y As Single)
Dim Line&
On Error GoTo Err:
    Dim VBCP As VBIDE.CodePane
    Set VBCP = VBInstance.ActiveCodePane
    If (VBCP Is Nothing) Then Exit Sub
    Dim VBCM As VBIDE.CodeModule
    Set VBCM = VBCP.CodeModule
    If (VBCM Is Nothing) Then Exit Sub
    Line& = CalcPicGraphToCodeLine(Y, VBCP, VBCM, True)
    
    'Make it easier to get to the first lines
    'If (Line& < 8) Then Line& = 1
    
    'Set the line
    VBCP.TopLine = Line&
    
    'Refresh
    DrawLines
    
    CheckForSubFunction Line&, VBCP, VBCM
    'DEBUG
    'Me.Caption = "Y: " & Y & ", Line:" & Line
    'Me.Line (0, Y)-(PicGraph.Width, Y), RGB(0, 255, 0)
    
Err:
End Sub

'========================================================
'Look for Sub/function name for easier navigation
'========================================================
Private Sub CheckForSubFunction(Line&, VBCP As Object, VBCM As Object)
Dim StartLine&, EndLine&, Range&, St&, En&, LookFor$, Col&, ColEnd&
Dim LineText$, ProcName$, Found As Boolean
    
    'Calculate the lines arround the mouse
    Range& = VBCM.CodePane.CountOfVisibleLines
    StartLine& = Line&
    'Sanity check
    If (StartLine& < 1) Then StartLine& = 1
    EndLine& = StartLine& + Range&
    If (EndLine& > Totlines) Then EndLine& = Totlines
    
    'Look for sub
    St& = StartLine&: En& = EndLine&: LookFor$ = " Sub "
    Do
        If (VBCM.Find(LookFor$, St&, Col&, En&, ColEnd&)) Then
            'If found a sub/function grabthe name
            If (Col& = 7) Or (Col& = 8) Then
                LineText$ = VBCM.Lines(St&, 1)
                ProcName$ = Mid$(LineText$, ColEnd&, InStr(ColEnd&, LineText$, "(") - ColEnd&)
                Found = True
                Exit Do
            End If
        End If
        St& = En& + 1: En& = EndLine&
    Loop While (St& <= EndLine&)
    
    If Not (Found) Then
        St& = StartLine&: En& = EndLine&: LookFor$ = " Function "
        Do
            If (VBCM.Find(LookFor$, St&, Col&, En&, ColEnd&)) Then
                'If found a sub/function grabthe name
                If (Col& = 7) Or (Col& = 8) Then
                    LineText$ = VBCM.Lines(St&, 1)
                    ProcName$ = Mid$(LineText$, ColEnd&, InStr(ColEnd&, LineText$, "(") - ColEnd&)
                    Found = True
                    Exit Do
                End If
            End If
            St& = En& + 1: En& = EndLine&
        Loop While (St& <= EndLine&)
    End If
    
    If (bMouseHeldDown) Then
        SetTooltip ProcName$, StartLine&, Range&
    Else
        'In case we have another tooltip system. The current one dont need to do anything to clear
        SetTooltip ""
    End If
    
End Sub

Private Sub SetTooltip(Tit$, Optional StartLine&, Optional Range&)
Dim PosY&, PosX& 'Position for drawing
Dim EndLine& 'Last visible line displayed
Dim STY&, ENY&, Diff& 'graphic position of the area displayed
Dim TextW& 'width of drawed text

    If (Tit$ = "") Then
        'Draw the buffer on the form avoiding flickering
        Me.PaintPicture PicGraph.Image, 0, 0
    Else
        EndLine& = StartLine& + Range&
        If (EndLine& > Totlines) Then
            EndLine = Totlines
            StartLine& = Totlines - Range
        End If
        STY = CalcCodeLineToPicGraph(StartLine&)
        ENY& = CalcCodeLineToPicGraph(StartLine& + Range&)
        Diff& = ENY - STY
            
        'PicGraph.Font.Name = "Segoe Condensed"
        'PicGraph.Font.Size = "12"
        
        'Align left
        'PosX = 2
        
        'Align Right
        TextW& = PicGraph.TextWidth(Tit$) + 10
        PosX = PicGraph.Width - TextW&
        If (PosX < 2) Then PosX = 2
        
        PosY& = STY - (PicGraph.TextHeight(Tit$) + 2)
        If (PosY& > STY + (Diff& / 2)) Then PosY& = STY + (Diff& / 2)
        If (PosY& < Diff& / 2) Then
            PosY& = ENY& + 3
        Else
        End If
        
        'Shadow
        PicGraph.CurrentX = PosX - 2
        PicGraph.CurrentY = PosY + 1
        PicGraph.ForeColor = vbBlack
        PicGraph.Print Tit$
        'Shadow2
        PicGraph.CurrentX = PosX
        PicGraph.CurrentY = PosY + 2
        PicGraph.ForeColor = vbBlack
        PicGraph.Print Tit$
        'Shadow3
        PicGraph.CurrentX = PosX + 2
        PicGraph.CurrentY = PosY + 1
        PicGraph.ForeColor = vbBlack
        PicGraph.Print Tit$
        'Text
        PicGraph.CurrentX = PosX
        PicGraph.CurrentY = PosY
        PicGraph.ForeColor = vbYellow
        PicGraph.Print Tit$
        
        'Draw the buffer on the form avoiding flickering
        Me.PaintPicture PicGraph.Image, 0, 0
    End If
End Sub

'===================================================================
'Calculate the line of code corresponding to Y px from Document map
'===================================================================
Private Function CalcPicGraphToCodeLine(ByVal Y!, VBCP As Object, VBCM As Object, Optional bCentered As Boolean) As Long
On Error GoTo Err:
    'In case we are doubling/skipping lines
    Y = Y * GraphMult * GraphStep
    
    'Aim for the center
    If (bCentered) Then
        Y = Y - (VBCP.CountOfVisibleLines / 2)
    End If
    
    'Check if we clicked past the code
    If (Y + VBCP.CountOfVisibleLines > VBCM.CountOfLines) Then
        Y = VBCM.CountOfLines - (VBCP.CountOfVisibleLines - 2)
    End If
    
    CalcPicGraphToCodeLine = CLng(Y)
    Exit Function
Err:
    Me.Caption = Err.Description
End Function


'================================================================
'Calculate the Y px in Document Map for the line of code
'================================================================
Private Function CalcCodeLineToPicGraph(ByVal Line&, Optional VBCP As Object, Optional VBCM As Object) As Long
On Error GoTo Err:
Dim Y As Single
    If (VBCP Is Nothing) Then
        Set VBCP = VBInstance.ActiveCodePane
        Set VBCM = VBCP.CodeModule
    End If
    
    'In case we are doubling/skipping lines
    Y = (Line * gDrawWidth&) / GraphStep
    
    CalcCodeLineToPicGraph = CLng(Y)
    Exit Function
Err:
    Me.Caption = Err.Description
End Function



'======================================
' Put ALWAYS ON TOP a window
'======================================
Private Sub MnuOnTop_Click()
    If (MnuOnTop.Checked = False) Then
        MnuOnTop.Checked = True
        Call SetWindowPos(Me.hWnd, -1, 0, 0, 0, 0, 3)
    Else
        MnuOnTop.Checked = False
        Call SetWindowPos(Me.hWnd, -2, 0, 0, 0, 0, 3)
    End If
End Sub

