VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.2#0"; "MSCOMCTL.OCX"
Begin VB.Form frmListControls 
   Caption         =   "Controls with resize data"
   ClientHeight    =   6240
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   4320
   BeginProperty Font 
      Name            =   "Segoe Condensed"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   6240
   ScaleWidth      =   4320
   StartUpPosition =   3  'Windows Default
   Begin MSComctlLib.ListView LV 
      Height          =   6165
      Left            =   30
      TabIndex        =   0
      Top             =   60
      Width           =   4245
      _ExtentX        =   7488
      _ExtentY        =   10874
      View            =   3
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      AllowReorder    =   -1  'True
      FlatScrollBar   =   -1  'True
      FullRowSelect   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Segoe UI"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      NumItems        =   2
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Control"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Data"
         Object.Width           =   2540
      EndProperty
   End
End
Attribute VB_Name = "frmListControls"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


Private Sub Form_Load()
    Me.Icon = frmAddIn.Icon
End Sub

Public Sub ShowList(VbInstance As VBIDE.VBE, TAG_SEPARATOR$)
On Error GoTo Err
Dim comp As VBComponent
Dim vbf As VBForm
Dim Ctrl As VBControl
Dim ControlTag$, ControlName$
Dim lPos As Long ' holder of the separator position in the tag
Dim bFound As Boolean
Dim li As ListItem

    frmAddIn.OnTop frmAddIn, False

    LV.ListItems.Clear
    LV.HideColumnHeaders = False


    If Not (VbInstance.SelectedVBComponent Is Nothing) Then
        Set vbf = VbInstance.SelectedVBComponent.Designer
        For Each Ctrl In vbf.VBControls
            ControlTag = Ctrl.Properties("Tag")
            'Si tiene tag de posicin lo muestro
            lPos = InStr(ControlTag, TAG_SEPARATOR$)
            If lPos > 0 Then
                ControlName$ = NameOf(Ctrl)
                
                Set li = LV.ListItems.Add(, , ControlName$)
                li.ListSubItems.Add , , Mid(ControlTag, 1, lPos - 1)
                
                'MsgBox ControlName$ & " - " & Mid(ControlTag, 1, lPos - 1)
                bFound = True
            End If
        Next
        
        If Not (bFound) Then
            MsgBox "There was no controls with resize info", vbInformation
            frmAddIn.OnTop frmAddIn, True
            Unload Me
        Else
            Me.Move frmAddIn.Left, frmAddIn.Top
            Me.Show
            Form_Resize
        End If
    Else
        MsgBox "No form selected", vbInformation
    End If
    frmAddIn.OnTop frmAddIn, True
    Exit Sub
Err:
    frmAddIn.OnTop frmAddIn, True
    MsgBox "Error: " & Err.Description
End Sub

Private Function NameOf(ByRef Ctrl As VBControl) As String
' Returns the composite name of the control, Index included if present
    NameOf = Ctrl.Properties("Name")
    If Ctrl.Properties("Index") <> "-1" Then NameOf = NameOf & "(" & Ctrl.Properties("Index") & ")"
End Function

Private Sub Form_Resize()
    LV.Width = Me.ScaleWidth - (LV.Left + 30)
    LV.Height = Me.ScaleHeight - (LV.Top + 30)
    LV.ColumnHeaders(1).Width = LV.Width * 0.45
    LV.ColumnHeaders(2).Width = LV.Width * 0.55
End Sub
